/******************************************************************/
/*									                              */
/*      Description : File reading process                        */
/*      Making Date : 2010. 05. 06					              */
/*      Affiliate   : Machine Learning Lab in SoongSil Univ       */
/*      Developer   : Sungin Park(rfchief@gmail.com)              */
/******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FileReader.h"
#include "utilFunc.h"

int GetData(char* a_FileName, float* a_fData1, char** labelData, int a_nSize)
{
	FILE* oReadFile;
	int nRow = 0;
	int nCol = 0;
	int nDataCnt1=0;
	int nDataCnt2=0;		
	char strBuf[50]={0,};

	if(a_FileName == NULL || a_fData1 == NULL || a_nSize<1)
		return 0;

	oReadFile = fopen(a_FileName, "r");
	if(!oReadFile) return 0;

	while(1){
			
		if(fscanf(oReadFile, "%s", strBuf) == EOF){			
			break;
		}else{	
			if(nDataCnt1 > ((a_nSize*a_nSize) - 1)){				
				nDataCnt1 = -1;
				break;
			}

			if(nRow > 0)
			{
				if(nCol > 0){

					strBuf[strlen(strBuf)-1]=NULL;					
					a_fData1[nDataCnt1]=(float)atof(strBuf);								
					nDataCnt1++;					
					nCol++;

					if(nCol == (a_nSize+1)){
						nCol = 0;						
					}

				}else{					
					nCol++;					
				}
			}else if(nRow == 0){
				labelData[nDataCnt2] = (char *)malloc(strlen(strBuf) * sizeof(char));
				strBuf[strlen(strBuf)]=NULL;				
				strcpy(labelData[nDataCnt2], strBuf);
				nDataCnt2++;
				
				if(nDataCnt2 == a_nSize){
					nRow++;
				}
			}//if nRow				
		}//fscanf if		

	}//while

	if(nDataCnt1 != (a_nSize*a_nSize)){
		printf("!!!!The number of objects is not match in input data.\n");	
		free(a_fData1);
		free(labelData);
		fclose(oReadFile);
		
		return 0;
	}

	fclose(oReadFile);
	return 1;
}


int GetData2(char* a_FileName, float* a_fData1, int a_nSize)
{
	FILE* oReadFile;
	int nDataCnt1=0;	
	char strBuf[50]={0,};

	if(a_FileName == NULL || a_fData1 == NULL || a_nSize<1)
		return 0;

	oReadFile = fopen(a_FileName, "r");
	if(!oReadFile) return 0;

	while(1){

		if(fscanf(oReadFile, "%s", strBuf) == EOF){
			break;
		}else{		
			if(nDataCnt1 > ((a_nSize*a_nSize) - 1)){				
				nDataCnt1 = -1;
				break;
			}

			strBuf[strlen(strBuf)-1]=NULL;			
			a_fData1[nDataCnt1]=(float)atof(strBuf);			
			nDataCnt1++;		
		}
		
	}//while
	
	if(nDataCnt1 != (a_nSize*a_nSize)){
		printf("!!!!The number of objects is not match in input data.\n");	
		free(a_fData1);
		fclose(oReadFile);		

		return 0;
	}

	fclose(oReadFile);
	return 1;
}
